// RPSDlg.cpp : implementation file
//

#include "stdafx.h"
#include <deque>
#include "RPS.h"
#include "RPSDlg.h"
#include ".\rpsdlg.h"
#include "StringPredictor.h"
#include "Entry.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


using namespace std;

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CRPSDlg dialog


CRPSDlg::CRPSDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRPSDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_ppredictor = new CStringPredictor();
	m_computerScore = 0;
	m_playerScore = 0;
}

CRPSDlg::~CRPSDlg()
{
	delete m_ppredictor;
}

void CRPSDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_ROCK, m_btRock);
	DDX_Control(pDX, IDC_COMPUTER_MOVE, m_computerMove);
	DDX_Control(pDX, IDC_COMPUTER_SCORE, m_computerScoreLabel);
	DDX_Control(pDX, IDC_PLAYER_MOVE, m_playerMove);
	DDX_Control(pDX, IDC_PLAYER_SCORE, m_playerScoreLabel);
	DDX_Control(pDX, IDC_SEQUENCE, m_sequenceLabel);
	DDX_Control(pDX, IDC_NEXTMOVE, m_nextMoveLabel);
}

BEGIN_MESSAGE_MAP(CRPSDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_ROCK, OnBnClickedRock)
	ON_BN_CLICKED(IDC_PAPER, OnBnClickedPaper)
	ON_BN_CLICKED(IDC_SCISSORS, OnBnClickedScissors)
END_MESSAGE_MAP()


// CRPSDlg message handlers

BOOL CRPSDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRPSDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRPSDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

CStringPredictor::Move CRPSDlg::computerMakeMove()
{
	// Predict the player's next move
	CStringPredictor::Move prediction = m_ppredictor->predictNextMove();
	if(prediction == CStringPredictor::UNKNOWN)
	{	// Can't predict, make a random guess
		prediction = (CStringPredictor::Move)(rand() % 3);
	}

	// Do the counter move to the predicted player's move
	CStringPredictor::Move compMove;
	if(prediction == CStringPredictor::ROCK)
	{
		compMove = CStringPredictor::PAPER;
		m_computerMove.SetWindowText("PAPER");
	} else if(prediction == CStringPredictor::PAPER)
	{
		compMove = CStringPredictor::SCISSORS;
		m_computerMove.SetWindowText("SCISSORS");
	} else if(prediction == CStringPredictor::SCISSORS)
	{
		compMove = CStringPredictor::ROCK;
		m_computerMove.SetWindowText("ROCK");
	}
	return compMove;
}

//
// Figures out the winner of this round given the moves of the player and computer.
// Updates the score accordingly.
//
void CRPSDlg::determineWinner(CStringPredictor::Move playerMove, CStringPredictor::Move compMove)
{
	// Let's see who won
	if(playerMove == compMove)
	{	// made same move - tie
		return;
	}

	bool playerWins;	// true if player won, false if comp won this round
	if(playerMove == CStringPredictor::ROCK)
	{
		if(compMove == CStringPredictor::SCISSORS)
		{	// player beat comp - rock beats scissors
			playerWins = true;
		} else
		{	// comp beat player - paper beats rock
			playerWins = false;
		}
	} else if(playerMove == CStringPredictor::SCISSORS)
	{
		if(compMove == CStringPredictor::PAPER)
		{	// player beat comp - scissors beats paper
			playerWins = true;
		} else
		{	// comp beat player - rock beats scissors
			playerWins = false;
		}
	} else if(playerMove == CStringPredictor::PAPER)
	{
		if(compMove == CStringPredictor::ROCK)
		{	// player beat comp - paper beats rock
			playerWins = true;
		} else
		{	// comp beat player - scissors beats paper
			playerWins = false;
		}
	}

	// Update the scores
	char scoreStr[7];
	if(playerWins)
	{
		m_playerScore++;
		itoa(m_playerScore, scoreStr, 10);
		m_playerScoreLabel.SetWindowText(scoreStr);
	} else
	{
		m_computerScore++;
		itoa(m_computerScore, scoreStr, 10);
		m_computerScoreLabel.SetWindowText(scoreStr);
	}
	UpdateData(FALSE);
}

//
// Displays the current sequence of moves by the player.
//
void CRPSDlg::showSequence()
{
#ifdef SHOW_SEQUENCE
	deque<CEntry*> *psequence = m_ppredictor->getSequence();
	static const int SIZE = 50;
	static const int SPACE = 5;
	char text[SIZE];
	char temp[SPACE - 1];
	memset(text, ' ', SIZE);
	int index = SIZE - SPACE - 2;
	for(int i = (int)psequence->size() - 1; i >= 0 && index >= SPACE; i--)
	{
		if(psequence->at(i)->getMove() == CStringPredictor::ROCK)
		{
			text[index] = 'R';
		} else if(psequence->at(i)->getMove() == CStringPredictor::PAPER)
		{
			text[index] = 'P';
		} else
		{
			text[index] = 'S';
		}

		itoa(psequence->at(i)->getCount(), temp, 10);
		strcpy(text + index + 1, temp);
		index -= SPACE;
	}
	for(int i = 0; i < SIZE; i++)
	{
		if(text[i] == 0) text[i] = ' ';
	}
	text[SIZE - 1] = 0;
	m_sequenceLabel.SetWindowText(text);


	// Predict the player's next move
	CStringPredictor::Move prediction = m_ppredictor->predictNextMove();

	// Do the counter move to the predicted player's move
	if(prediction == CStringPredictor::ROCK)
	{
		m_nextMoveLabel.SetWindowText("ROCK");
	} else if(prediction == CStringPredictor::PAPER)
	{
		m_nextMoveLabel.SetWindowText("PAPER");
	} else if(prediction == CStringPredictor::SCISSORS)
	{
		m_nextMoveLabel.SetWindowText("SCISSORS");
	} else
	{
		m_nextMoveLabel.SetWindowText("UNKNOWN");
	}

#endif // SHOW_SEQUENCE
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRPSDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CRPSDlg::OnBnClickedRock()
{
	CStringPredictor::Move compMove = computerMakeMove();
	determineWinner(CStringPredictor::ROCK, compMove);
	m_ppredictor->addEntry(CStringPredictor::ROCK);
	m_playerMove.SetWindowText("ROCK");
	showSequence();
}

void CRPSDlg::OnBnClickedPaper()
{
	CStringPredictor::Move compMove = computerMakeMove();
	determineWinner(CStringPredictor::PAPER, compMove);
	m_ppredictor->addEntry(CStringPredictor::PAPER);
	m_playerMove.SetWindowText("PAPER");
	showSequence();
}

void CRPSDlg::OnBnClickedScissors()
{
	CStringPredictor::Move compMove = computerMakeMove();
	determineWinner(CStringPredictor::SCISSORS, compMove);
	m_ppredictor->addEntry(CStringPredictor::SCISSORS);
	m_playerMove.SetWindowText("SCISSORS");
	showSequence();
}
