// StringPredictor.cpp : implementation file
//

#include "stdafx.h"
#include "RPS.h"
#include "StringPredictor.h"
#include <deque>
#include "Entry.h"


using namespace std;

// CStringPredictor

CStringPredictor::CStringPredictor() :
m_maxMatchIndex(0),
m_maxMatchSize(0)
{
}

CStringPredictor::~CStringPredictor()
{
	for(UINT i = 0; i < m_sequence.size(); i++)
	{
		delete m_sequence[i];
	}
}


// CStringPredictor member functions

//
// Adds a new entry to the sequence of observed moves.
// This will update both the sequence and histogram.
//
void CStringPredictor::addEntry(Move move)
{
	m_maxMatchSize = 0;
	for(int i = (int)m_histogram[move].size() - 1; i >= 0; i--)
	{	// update the counts for all entries of type move in sequence
		int curEntryIndex = m_histogram[move][i];
		int curEntryCount = 1;	// If this is first entry its count is 1
		if(curEntryIndex != 0)
		{	// Only go in here if this isn't the first entry
			curEntryCount = m_sequence[curEntryIndex - 1]->getCount() + 1;
		}
		m_sequence[curEntryIndex]->setCount(curEntryCount);
		if(curEntryCount > m_maxMatchSize)
		{
			m_maxMatchSize = curEntryCount;
			m_maxMatchIndex = curEntryIndex;
		}
	}
	m_histogram[move].push_back((int)m_sequence.size());
	m_sequence.push_back(new CEntry(move));
}

//
// Returns the predicted next move in the sequence.
//
CStringPredictor::Move CStringPredictor::predictNextMove()
{
	if(m_maxMatchSize > 0)
	{
		return m_sequence[m_maxMatchIndex + 1]->getMove();
	}
	return UNKNOWN;
}

CStringPredictor::Move CStringPredictor::getLastMove()
{
	return m_sequence.back()->getMove();
}
