#pragma once

class CEntry;

#include <deque>

// CStringPredictor command target

class CStringPredictor : public CObject
{
public:
	enum Move
	{
		ROCK, PAPER, SCISSORS, UNKNOWN
	};
public:
	CStringPredictor();
	virtual ~CStringPredictor();

	void addEntry(Move move);
	Move predictNextMove();

	Move getLastMove();

#ifdef SHOW_SEQUENCE
	std::deque<CEntry*> *getSequence() {return &m_sequence;}
#endif	// SHOW_SEQUENCE	

private:
	std::deque<CEntry*> m_sequence;
	std::deque<int> m_histogram[3]; // same size as # elements in enum Move - 1
	int m_maxMatchIndex;	// index in sequence where end of largest match is
	int m_maxMatchSize;	// the actual length of the largest match
};


